/******************************************
 *                                        *
 *   SMPC SAMPLE PROGRAM Version 0.56a    *
 *                                        *
 *    file : command.c                    *
 *                                        *
 *  author : s.uchida sega cs h/w r&d     *
 *                                        *
 *    date : 94/11/09                     *
 *                                        *
 ******************************************/


#include "ssp.h"

#define SMEMX 12
#define SMEMY 11

#define CMD_MSHON	0
#define CMD_SSHON	1
#define CMD_SSHOFF	2
#define CMD_SNDON	3
#define CMD_SNDOFF	4
#define CMD_CDON	5
#define CMD_CDOFF	6
#define CMD_SYSRES	7
#define CMD_CKCHG352    8
#define CMD_CKCHG320	9
#define CMD_NMIREQ	10
#define CMD_RESENAB	11
#define CMD_RESDISA	12
#define CMD_INTBACK	13
#define CMD_SETSMEM	14
#define CMD_SETTIME	15

#define CMDSET(No,Str1,Str2,Code) \
		strcpy(cmd[No].name,Str1);\
		strcpy(cmd[No].shortname,Str2);\
		cmd[No].code = Code

Uint8 smpc_cmdresult;

static void printcmdcode(Uint8,Uint8);
static MENU_Body smm;
static struct cmd {
		Sint8 name[20];
		Sint8 shortname[12];
		Uint8 code;
	} cmd[16];

static Uint8 smem[6];

/*******************
 SMPC COMMAND
 *******************/

void smpccommand(void)
{
	Uint8 i;
	Uint8 cmdno;
	void setsmem(void);
	void settime(void);
	void cmdexec(Uint8);
	void setireg(Uint8);
	MENU_Body smpccmd;

	CMDSET( 0,"MASTER SH2 ON   ","MSHON",	0x00);
	CMDSET( 2,"SLAVE SH2 ON    ","SSHON",	0x02);
	CMDSET( 3,"SLAVE SH2 OFF   ","SSHOFF",	0x03);
	CMDSET( 4,"SOUND CPU ON    ","SNDON",	0x06);
	CMDSET( 5,"SOUND CPU OFF   ","SNDOFF",	0x07);
	CMDSET( 6,"CD ON           ","CDON",	0x08);
	CMDSET( 7,"CD OFF          ","CDOFF",	0x09);
	CMDSET( 1,"SYSTEM RESET    ","SYSRES",	0x0d);
	CMDSET( 8,"CLOCK CHANGE 352","CKCHG352",0x0e);
	CMDSET( 9,"CLOCK CHANGE 320","CKCHG320",0x0f);
	CMDSET(12,"NMI REQUEST     ","NMIREQ",	0x18);
	CMDSET(10,"RESET ENABLE    ","RESENAB",	0x19);
	CMDSET(11,"RESET DISABLE   ","RESDISA",	0x1a);
	CMDSET(13,"INTERRUPT BACK  ","INTBACK",	0x10);
	CMDSET(14,"SET SMPC MEMORY ","SETSMEM",	0x17);
	CMDSET(15,"SET DATE/TIME   ","SETTIME",	0x16);
	MENUTITLE(smpccmd,"[COMMAND]");

	for(i=0;i<16;i++)
		MENUITEM(smpccmd,i,cmd[i].shortname);

	smpccmd.num = 16;
	smpccmd.column = 2;
	smpccmd.line = smpccmd.num / smpccmd.column;
	smpccmd.xstep = 10;
	smpccmd.ystep = 2;
	smpccmd.lmenux = 0;
	smpccmd.lmenuy = 0;
	smpccmd.menutype = MENU_FUNC_ENABLE | MENU_CSRTYP_NORM;
	smpccmd.menufunc = *printcmdcode;

	gcls();
	statusline();
	putstr(10,1,"[SMPC COMMAND TEST]",WHITE);
	while(ProgramMode == CMDTEST){
		box(0,20,16,2);					/* cmd name */
		box(18,20,2,2);					/* cmd code */
		box(22,2,15,16);				/* status */
		putstr(24,2,"[STATUS]",0);

#if 0
		box(23,20,9,2);					/* result */
		putstr(24,21,"RESULT",WHITE);
		putstr(24,22,"PARAMETER",WHITE);
		box(34,20,2,2);					/* res code */
#endif
	    smpcdispsub(23,3);
		printcmdcode(smpccmd.lmenuy * smpccmd.column + smpccmd.lmenux,0);
		smpcdisporeg(26,3);

/*		putstr(35,22,itos(smpc_cmdresult,16,2),0);*/

		cmdno = menu(0,2,smpccmd);
		smpccmd.lmenux = cur.x;
		smpccmd.lmenuy = cur.y;
		switch(cmdno){
			case CANCEL:
		                ProgramMode = MENU;
				break;
			case CMD_MSHON:
			case CMD_SSHON:
			case CMD_SSHOFF:
			case CMD_SNDON:
			case CMD_SNDOFF:
			case CMD_CDON:
			case CMD_CDOFF:
			case CMD_SYSRES:
			case CMD_NMIREQ:
			case CMD_RESENAB:
			case CMD_RESDISA:
				cmdexec(cmdno);
				break;
			case CMD_INTBACK:
				break;
			case CMD_SETSMEM:
				setireg(0);
				break;
			case CMD_SETTIME:
				setireg(1);
				break;
			case CMD_CKCHG352:
			case CMD_CKCHG320:
				break;
			      default:
				ProgramMode = MENU;
				break;
		}
	}		/* end of while */
}


/******************************************
 *                                        *
 * PRINT CMD CODE 
 *                                        *
 ******************************************/


void printcmdcode(Uint8 select,Uint8 dummy)
{
	putstr(1,22,cmd[select].name,WHITE);
	putstr(19,22,itos(cmd[select].code,16,2),WHITE);
}


/*----------------------------------------*
 *                                        *
 * CMD EXEC
 *                                        *
 -----------------------------------------*/


void cmdexec(Uint8 cmdno)
{
    Uint32 i;
	while(SMPCBUSY)
		;
	pokeb(0x20100063,1);
	pokeb(0x2010001f,cmd[cmdno].code);


}


/******************************************
 *                                        *
 * SMEM VALUE
 *                                        *
 ******************************************/

void smem_value(Uint8 no,Uint8 btn)
{

	if(btn == LEFT || btn == RIGHT || btn == L_BTN || btn == R_BTN)
		return;

	if(btn == UP)
		smem[no]--;

	if(btn == DOWN)
		smem[no]++;

	strcpy(cur.menu.item[no],itos(smem[no],16,2));
	putstr(SMEMX + 2 + no * 3,SMEMY + 2,cur.menu.item[no],0x80);
}



/*----------------------------------------*
 *                                        *
 * SET IREG
 *                                        *
 -----------------------------------------*/


void setireg(Uint8 no)
{
	Uint8 i;
	Uint8 loop[2];
	Uint8 ofs[2];
	Uint8 ttl[2][32];
	Uint8 cmdno[2];

	loop[0] = 4 ; loop[1] = 7;
	ofs[0] = 12 ; ofs[1] = 1;
	cmdno[0] = CMD_SETSMEM;
	cmdno[1] = CMD_SETTIME;
	strcpy(ttl[0],"SET MEMORY");
	strcpy(ttl[1],"[SET DATE/TIME]");


	for(i = 0;i < loop[no];i++){
		smem[i] = oreg[i + ofs[no]];
		MENUITEM(smm,i,itos(smem[i],16,2));
	}

	MENUTITLE(smm,ttl[no]);

	smm.num = loop[no];
	smm.column = loop[no];
	smm.line = 1;
	smm.xstep = 3;
	smm.ystep = 2;
	smm.lmenux = 0;
	smm.lmenuy = 0;
	smm.menutype = MENU_CSRTYP_NORM | MENU_FUNC_ENABLE;
	smm.menufunc = smem_value;

	if(menu(SMEMX,SMEMY,smm)==CANCEL)
		return;

	while(SMPCBUSY)
	  ;
	for(i = 0;i < smm.column;i++)
		pokeb(0x20100001+i*2,smem[i]);

	cmdexec(cmdno[no]);
}


/********************
 SMPCDISPSUB
 ********************/

void smpcdispsub(Uint8 x,Uint8 y)
{
	Uint8 i;

	for(i = 0; i < 16; i++){
		putstr(x,i+y,itos(i,10,2),WHITE);
		putstr(x+2,i+y,"(  :        )",WHITE);
	}
}

/****************
 SMPCDISPOREG
 ****************/

void smpcdisporeg(Uint8 x,Uint8 y)
{
	Uint8 i;

	for(i = 0; i < 16;i++){
		putstr(x,i+y,itosh2(oreg[i]),WHITE);
		putstr(x+3,i+y,itos(oreg[i],2,8),WHITE);
	}
}


/********************** END COMMAND.C **************************/
