/******************************************
 *                                        *
 *   SMPC SAMPLE PROGRAM Version 0.56a    *
 *                                        *
 *    file : init.c                       *
 *                                        *
 *  author : s.uchida sega cs h/w r&d     *
 *                                        *
 *    date : 94/11/09                     *
 *                                        *
 ******************************************/



#include "ssp.h"


static Uint8 bitpat[] = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};


/******************************************
 *                                        *
 * INIT
 *                                        *
 ******************************************/



void Init(void);


void Init(void)
{
	Uint8 i;

	void SetPalette(void);
	void DefLineColor(void);
	void DeviceInit(void);
	void movefont(void);
	void SprInit(void);

	SetPalette();
	DefLineColor();
	DeviceInit();
	movefont();
	SprInit();
}


/*----------------------------------------*
 *                                        *
 * SET PALETTE
 *                                        *
 -----------------------------------------*/


void SetPalette(void)
{
	Uint16	r,g,b;
	Uint16	i,*palette;

	SCL_SetColRamMode(SCL_CRM15_2048);
	SCL_AllocColRam(SCL_NBG0 |SCL_NBG1 |SCL_NBG2 |SCL_NBG3 |
					SCL_RBG0 |SCL_RBG1 |
					SCL_SP0 |SCL_SP1 |SCL_SP2 |SCL_SP3 |
					SCL_SP4 |SCL_SP5 |SCL_SP6 |SCL_SP7 , 2048,OFF);

	palette = (Uint16 *)(0x25f00000);

	i = 0;
	for(b=0;b<4;b++)
		for(g=0;g<8;g++)
			for(r=0;r<8;r++){
				*(palette+    i) = (Uint16)(r*4+g*128+b*4096*2);
				*(palette+256+i) = (Uint16)(g*4+b*128*2+r*4096);
				*(palette+512+i) = (Uint16)(b*4*2+r*128+g*4096);
				i++;
			}
	pokew(0x25f00010,0x8000);


}


/*----------------------------------------*
 *                                        *
 * DEF LINE COLOR
 *                                        *
 -----------------------------------------*/

void DefLineColor(void)
{
	linecolor[BLACK][0] = RGB16(7,7,3);
	linecolor[BLACK][1] = RGB16(6,6,3);
	linecolor[BLACK][2] = RGB16(6,6,3);
	linecolor[BLACK][3] = RGB16(5,5,2);
	linecolor[BLACK][4] = RGB16(5,5,2);
	linecolor[BLACK][5] = RGB16(4,4,2);
	linecolor[BLACK][6] = RGB16(3,3,1);
	linecolor[BLACK][7] = RGB16(2,2,1);

	linecolor[BLUE][0] = RGB16(7,7,3);
	linecolor[BLUE][1] = RGB16(7,7,3);
	linecolor[BLUE][2] = RGB16(6,6,3);
	linecolor[BLUE][3] = RGB16(5,5,3);
	linecolor[BLUE][4] = RGB16(4,4,3);
	linecolor[BLUE][5] = RGB16(3,3,3);
	linecolor[BLUE][6] = RGB16(2,2,3);
	linecolor[BLUE][7] = RGB16(1,1,3);

	linecolor[RED][0] = RGB16(7,7,3);
	linecolor[RED][1] = RGB16(7,7,3);
	linecolor[RED][2] = RGB16(7,6,3);
	linecolor[RED][3] = RGB16(7,5,2);
	linecolor[RED][4] = RGB16(7,4,2);
	linecolor[RED][5] = RGB16(7,3,1);
	linecolor[RED][6] = RGB16(7,2,1);
	linecolor[RED][7] = RGB16(7,1,1);

	linecolor[VIOLET][0] = RGB16(7,7,3);
	linecolor[VIOLET][1] = RGB16(7,7,3);
	linecolor[VIOLET][2] = RGB16(7,6,3);
	linecolor[VIOLET][3] = RGB16(7,5,3);
	linecolor[VIOLET][4] = RGB16(7,4,3);
	linecolor[VIOLET][5] = RGB16(7,3,3);
	linecolor[VIOLET][6] = RGB16(7,2,3);
	linecolor[VIOLET][7] = RGB16(7,1,3);

	linecolor[GREEN][0] = RGB16(7,7,3);
	linecolor[GREEN][1] = RGB16(6,7,3);
	linecolor[GREEN][2] = RGB16(5,7,2);
	linecolor[GREEN][3] = RGB16(4,7,2);
	linecolor[GREEN][4] = RGB16(3,7,1);
	linecolor[GREEN][5] = RGB16(2,7,1);
	linecolor[GREEN][6] = RGB16(1,7,0);
	linecolor[GREEN][7] = RGB16(0,7,0);

	linecolor[SKYBLUE][0] = RGB16(7,7,3);
	linecolor[SKYBLUE][1] = RGB16(7,7,3);
	linecolor[SKYBLUE][2] = RGB16(6,7,3);
	linecolor[SKYBLUE][3] = RGB16(5,7,3);
	linecolor[SKYBLUE][4] = RGB16(4,7,3);
	linecolor[SKYBLUE][5] = RGB16(3,7,3);
	linecolor[SKYBLUE][6] = RGB16(2,7,3);
	linecolor[SKYBLUE][7] = RGB16(1,7,3);

	linecolor[YELLOW][0] = RGB16(7,4,0);
	linecolor[YELLOW][1] = RGB16(7,4,0);
	linecolor[YELLOW][2] = RGB16(7,5,1);
	linecolor[YELLOW][3] = RGB16(7,5,1);
	linecolor[YELLOW][4] = RGB16(7,6,2);
	linecolor[YELLOW][5] = RGB16(7,6,2);
	linecolor[YELLOW][6] = RGB16(7,7,3);
	linecolor[YELLOW][7] = RGB16(7,7,3);

	linecolor[WHITE][0] = RGB16(7,7,3);
	linecolor[WHITE][1] = RGB16(7,7,3);
	linecolor[WHITE][2] = RGB16(7,7,3);
	linecolor[WHITE][3] = RGB16(7,7,3);
	linecolor[WHITE][4] = RGB16(7,7,3);
	linecolor[WHITE][5] = RGB16(7,7,3);
	linecolor[WHITE][6] = RGB16(7,7,3);
	linecolor[WHITE][7] = RGB16(7,7,3);
}


/*----------------------------------------*
 *                                        *
 * DEVICE INIT
 *                                        *
 -----------------------------------------*/

void DeviceInit(void)
{
	Uint8 i,j;

	port[0].id = 0x00;
	port[1].id = 0x00;

	device[PERMAX].SaturnID = 0xff;
	device[PERMAX].datamax = 0;
	for(i = 0; i < 5; i++)
	  device[PERMAX].data[i] = 0xff;    /*first 5 data bytes=ff*/

	device[PERMAX].Btn.A =              /*all buttons OFF*/
	  device[PERMAX].Btn.B =
	    device[PERMAX].Btn.C =
	      device[PERMAX].Btn.X =
		device[PERMAX].Btn.Y =
		  device[PERMAX].Btn.Z =
		    device[PERMAX].Btn.L =
		      device[PERMAX].Btn.R =
			device[PERMAX].Btn.S =
			  device[PERMAX].Btn.Up =
			    device[PERMAX].Btn.Down =
			      device[PERMAX].Btn.Left =
				device[PERMAX].Btn.Right =
				  device[PERMAX].Btn.ClickL =
				    device[PERMAX].Btn.ClickR =
				      device[PERMAX].Btn.ClickM = OFF;

	device[PERMAX].lBtn = device[PERMAX].Btn;   /*copy Btn to LBtn*/

	for(i = 0;i < PERMAX; i++)
	  device[i] = device[PERMAX];    /*copy device[PERMAX] to device[0-PERMAX]*/

	for(i = 0; i < 128; i++)         /*init OREG array(32x4) to 0*/
	  oreg[i] = 0;

}



/*----------------------------------------*
 *                                        *
 * MOVE FONT
 *                                        *
 -----------------------------------------*/

void movefont(void)
{
    Uint16 i;
    Uint8 *vram;
	void move1font(Uint8,Uint8 *);

	for(i=0;i<256;i++){
		vram = (Uint8 *)(SCL_VDP2_VRAM_A0+i*64);
		move1font(i,vram);
	}
}


void move1font(Uint8 No,Uint8 *vram)
{
    Sint8 byte,bit;
    Uint8 linedata,grad;

	for(byte=0;byte<64;byte++)
		*(vram+byte) = 0x00;

    byte = 0;
    while(byte<8){
		linedata = Font8[No*8+byte];
		bit = 7;
		while(bit>0){
			if(!(No>=101 && No<=114))
				if(bitpat[bit] & linedata) *(vram+1+8) = 0x08;
			bit--;
			vram++;
		}
		vram++;
		byte++;
    }

	vram -= 64;


    byte = 0;
    while(byte<8){
		linedata = Font8[No*8+byte];
		bit = 7;
		while(bit>=0){
			if(No>=101 && No<=114) grad = 5;
				else grad = byte;
			if(bitpat[bit] & linedata) *vram = linecolor[YELLOW][grad];
			bit--;
			vram++;
		}
		byte++;
    }
}



/*----------------------------------------*
 *                                        *
 * SPR INIT
 *                                        *
 -----------------------------------------*/

void SprInit(void)
{
    Uint8 *SpVram,i;
	void sprmake(void);

    SCL_SetSpriteMode(SCL_TYPE1,SCL_PALETTE,SCL_SP_WINDOW);
    SPR_Initial(&SpVram);
	SPR_SetEraseData(0x0000,0,0,319,223);

	for(i = 0; i < PERMAX; i++) spr[i].zoom = 0;

	sprmake();
    memcpy(SPRVRM + 0x10000, SpDat, 0x10*0x10*8);

	radian[0] =    0;
	radian[1] = 0.52;
	radian[2] = 1.04;
	radian[3] = 1.57;
	radian[4] = 2.09;
	radian[5] = 2.62;

	radian[6] = 3.14;
	radian[7] = 3.66;
	radian[8] = 4.18;
	radian[9] = 4.70;
	radian[10] = 5.23;
	radian[11] = 5.75;

}


/*----------------------------------------*
 *                                        *
 * SPRMAKE
 *                                        *
 -----------------------------------------*/


void sprmake(void)
{
	Uint16 i,j,k;

	for(i=1;i<7;i++)
		for(j=0;j<256;j++)
			SpDat[i+1][j] = SpDat[1][j];
	for(i=1;i<7;i++){
		for(j=0;j<8;j++){
			for(k=0;k<8;k++){
				if(bitpat[7-k] & Font8[(i+0x30)*8+j])
					SpDat[i+1][(j+5)*16+k+4] = linecolor[VIOLET][7-j];
			}
		}
	}
}

/******************* END INIT.C **************************/
