/******************************************
 *                                        *
 *   SMPC SAMPLE PROGRAM Version 0.56a    *
 *                                        *
 *    file : menu.h                       *
 *                                        *
 *  author : s.uchida sega cs h/w r&d     *
 *                                        *
 *    date : 94/11/09                     *
 *           12/1/94 a.stern

						 selmenu(); - function is executed every Vblank In and determines
						              the appropriate application function to run.
						 getmenudev(); - is called by selmenu();.
 *                                        *
 ******************************************/


#include "ssp.h"


#ifdef DEBUG
  #define dp(x,y,s,c) putstr(x,y,s,c)
#else
  #define dp(x,y,s,c)
#endif


#define MENUCSRX cur.cx + cur.x * cur.menu.xstep + 1
#define MENUCSRY cur.cy + cur.y * cur.menu.ystep + 2



static Sint8 *warnmsg[] = {"NOT   ","      ","READY!","      "};

static Uint8 RepeatSpeed = 10;
static Uint8 RepeatEnable = 0;
static Uint8 Pressed = 0;
static Uint8 DelaySpeed = 30;
static Uint8 repcnt = 0;
static Uint8 cursor1_typ = 0x20;
static Sint8 *cursor[] = {" ","s"};

static Uint8 MenuDevChg = ON;  /* 1...Search Device  0...Not Search Device */

static Uint8 result = NVALID;
static Uint8 MenuCsrTyp = MENU_CSRTYP_NORM;
static Uint8 MenuFuncEnable = MENU_FUNC_DISABLE;


/*----------------------------------------*
 *                                        *
 * MENU
 *                                        *
 -----------------------------------------*/

Uint8 menu(Uint8 x,Uint8 y,MENU_Body cm)
{
    Uint16 i = 0;
	Uint8 j,k = 0;

	result = NVALID;
	repcnt = 0;
	RepeatEnable = 0;
	Pressed = 0;
	MenuEnable = ON;
	cur.x = cm.lmenux;
	cur.y = cm.lmenuy;
	cur.cx = x;
	cur.cy = y;
	MenuFuncEnable = cm.menutype & MENU_FUNC_ENABLE;
	MenuCsrTyp = cm.menutype & MENU_CSRTYP_REV;

	box(x,y,cm.xstep*cm.column,cm.line*cm.ystep);
	putstr(x+2,y,cm.title,WHITE);

	for(j = 0;j < cm.line;j++)
		for(i = 0;i < cm.column;i++)
			putstr(x+i*cm.xstep+2,y+j*cm.ystep+2,cm.item[k++],WHITE);

	cur.menu = cm;

	while(result & NVALID)
	  putstr(17,BORDERLINE,itos((i++)/16,16,2),WHITE);

	MenuEnable = OFF;

	if(result & CANCEL)
	  return CANCEL;
	else
	  return result & 0x3f;
}

/******************************************
 *                                        *
 * SELECT MENU
 *                                        *
 ******************************************/


Uint8 selmenu(void)
{
    Uint8 i,j,x,y;
    void erase_cursor(void);
    void put_cursor(Uint8);
    void getmenudev(void);

    cursor1_typ++;

    if(!MenuEnable){		/* j[łȂΖlԂ */
		result = NVALID;
		return NVALID;
    }

    if(MenuDevChg || device[MenuDev].SaturnID == 0xff ||	/* j[yύXtOĂ邩 */
       device[MenuDev].SaturnID == MOUSE)					/* ܂͑쒆̃yꂽ       */
      getmenudev();											/* }EXő삵悤Ƃ           */
															/* j[yύX               */

    if(MenuDev == 0xff){									/* NOT READY message */
		Uint8 p = VBinCount >> 4 & 1;
		x=32,y=20;
		box(x,y,6,2);
		putstr(x+1,y+1,warnmsg[p],WHITE);
		putstr(x+1,y+2,warnmsg[p +2],WHITE);
		MenuDevChg = ON;
		result = NVALID;
		return NVALID;
    }


	for(i = 0; i < PERMAX; i++)		/* SET MenuDev */
		if(device[i].Btn.S){
		MenuDev = i;
		break;
	}



	x=32,y=20;						/* ʉEɃj[y\ */
	box(x,y,6,2);
	putfdev(x+1,y+1,MenuDev);

	Pressed = 0;					/* {^tO */
	put_cursor(0);


	/* 	`܂͂b{^ꂽ猋ʂԂ */

	if(device[MenuDev].Btn.A && (!device[MenuDev].lBtn.A || RepeatEnable)){
	    put_cursor(1);
	    result =  cur.y * cur.menu.column + cur.x;
	    return result;
	}

	if(device[MenuDev].Btn.C && (!device[MenuDev].lBtn.C || RepeatEnable)){
	    put_cursor(1);
	    result = cur.y * cur.menu.column + cur.x;
	    return result;
	}

	if(device[MenuDev].Btn.B && (!device[MenuDev].lBtn.B || RepeatEnable)){
	    result = CANCEL;
	    return result;
	}


	if(device[MenuDev].Btn.Left){
	    Pressed = 1;
	    if(!device[MenuDev].lBtn.Left || RepeatEnable){
		if(cur.x > 0){
		    erase_cursor();
		    cur.x--;
		    Pressed = 1;
		    put_cursor(1);
		}
		if(MenuFuncEnable)
		  (*cur.menu.menufunc)(cur.y * cur.menu.column + cur.x,LEFT);
	    }
	}

	if(device[MenuDev].Btn.Right){
	    Pressed = 1;
	    if(!device[MenuDev].lBtn.Right || RepeatEnable){
		if(cur.x < cur.menu.column - 1){
		    erase_cursor();
		    cur.x++;
		    Pressed = 1;
		    put_cursor(1);
		}
		if(MenuFuncEnable)
		  (*cur.menu.menufunc)(cur.y * cur.menu.column + cur.x,RIGHT);
	    }
	}
	if(device[MenuDev].Btn.Up){
	    Pressed = 1;
	    if(!device[MenuDev].lBtn.Up || RepeatEnable){
		if(cur.y > 0){
		    erase_cursor();
		    cur.y--;
		    Pressed = 1;
		    put_cursor(1);
		}
		if(MenuFuncEnable)
		  (*cur.menu.menufunc)(cur.y * cur.menu.column + cur.x,UP);
	    }
	}

	if(device[MenuDev].Btn.Down){
	    Pressed = 1;
	    if(!device[MenuDev].lBtn.Down || RepeatEnable){
		if(cur.y < cur.menu.line - 1){
		    erase_cursor();
		    cur.y++;
		    Pressed = 1;
		    put_cursor(1);
		}
		if(MenuFuncEnable)
		  (*cur.menu.menufunc)(cur.y * cur.menu.column + cur.x,DOWN);
	    }
	}

	if(device[MenuDev].Btn.L){
	    erase_cursor();
	    cur.x = 0;
	    cur.y = 0;
	    put_cursor(1);
	    if(MenuFuncEnable)
	      (*cur.menu.menufunc)(cur.y * cur.menu.column + cur.x,L_BTN);
	}

	if(device[MenuDev].Btn.R){
	    erase_cursor();
	    cur.x = cur.menu.column - 1;
	    cur.y = cur.menu.line - 1;
	    put_cursor(1);
	    if(MenuFuncEnable)
	      (*cur.menu.menufunc)(cur.y * cur.menu.column + cur.x,R_BTN);
	}


    dp(0,0,itos(cur.x,10,2),0);				/* fobOCg */
    dp(3,0,itos(cur.y,10,2),0);
    dp(6,0,itos(Pressed,2,1),0);
    dp(9,0,itos(repcnt,16,2),0);
    dp(12,0,itos(MenuDev,10,2),0);
    dp(15,0,itos(MenuDevChg,2,1),0);
    dp(18,0,itos(MenuFuncEnable,16,2),0);
    dp(21,0,itos(MenuCsrTyp,16,2),0);

	if(Pressed){							/* \L[ȂǂĂ */
	    repcnt++;							/* s[gJEg++ */
	    if(repcnt >= DelaySpeed){			/* s[gJEgfBCXs[h𒴂 */
		RepeatEnable = 1;					/* L[s[g悤ɂ */
		repcnt = DelaySpeed;
	    }
	} else {
	    repcnt = 0;
	    RepeatEnable = 0;
	}

	result = NVALID;						/* 삪ȂΖlԂ */
    return result;
}


/*----------------------------------------*
 *                                        *
 * ERASE CURSOR
 *                                        *
 -----------------------------------------*/


void erase_cursor(void)
{
    if(MenuCsrTyp == MENU_CSRTYP_NORM)
      putstr(MENUCSRX,MENUCSRY," ",WHITE);
    else {
	putstr(MENUCSRX+1,MENUCSRY,
	       cur.menu.item[cur.y * cur.menu.column + cur.x],WHITE);
    }
}


/*----------------------------------------*
 *                                        *
 * PUT CURSOR
 *                                        *
 -----------------------------------------*/


void put_cursor(Uint8 brink)
{
    if(MenuCsrTyp == MENU_CSRTYP_NORM){
	if(brink){
	    putstr(MENUCSRX,MENUCSRY,cursor[1],WHITE);
	    cursor1_typ = 0x20;
	}
	else
	  putstr(MENUCSRX,MENUCSRY,cursor[cursor1_typ>>5 & 1],WHITE);
    } else {
	if(brink){
	    putstr(MENUCSRX+1,MENUCSRY,
		   cur.menu.item[cur.y * cur.menu.column + cur.x],WHITE | 0x80);
	    cursor1_typ = 0x20;
	}
	else
	  putstr(MENUCSRX+1,MENUCSRY,
		 cur.menu.item[cur.y * cur.menu.column + cur.x],WHITE | ((cursor1_typ & 0x20)<<2));
    }
}



/******************************************
 *                                        *
 * BOX
 *                                        *
 ******************************************/


void box(Uint8 x1,Uint8 y1,Uint8 l,Uint8 k)
{
        Uint8 i,j;
        Uint8 x2,y2;

		l++;
        x2 = x1+l;
        y2 = k+1;

        putstr(x1,y1,"e",WHITE);
        for(i = 1; i < l; i++)
                putstr(x1+i,y1,"f",WHITE);
        putstr(x2,y1,"h",WHITE);

        for(i = 1; i < y2; i++){
                putstr(x1,y1+i,"i",WHITE);
                for(j = 1; j < l; j++)
                        putstr(x1+j,y1+i," ",WHITE);
                putstr(x2,y1+i,"l",WHITE);
        }

        putstr(x1,y1+y2,"n",WHITE);

        for(i = 1; i < l; i++)
                putstr(x1+i,y1+y2,"o",WHITE);
        putstr(x1+l,y1+y2,"q",WHITE);

}


/******************************************
 *                                        *
 * PUTFDEV
 *                                        *
 ******************************************/


void putfdev(Uint8 x,Uint8 y,Uint8 dev)
{
    putstr(x,y,device[dev].shortname,WHITE);
    putstr(x+2,y+1,itos(dev / PORTMAX + 1,10,1),WHITE);
    putstr(x+4,y+1,itos(dev % PORTMAX + 1,10,1),WHITE);
    putstr(x+1,y+1,"P",WHITE);
    putstr(x+3,y+1,"-",WHITE);
}


/******************************************
 *                                        *
 * YES NO
 *                                        *
 ******************************************/


Uint8 yesno(Uint8 x,Uint8 y,Uint8 def,Uint8 mode)
{
	MENU_Body yesno;

		mode &= 0x01;

	strcpy(yesno.title,"");

	MENUITEM(yesno,0,"YES");
	MENUITEM(yesno,1,"NO");

	yesno.num = 2;
	yesno.xstep = 5;
	yesno.ystep = 2;
	yesno.menutype = MENU_FUNC_DISABLE | MENU_CSRTYP_NORM;

	if(mode == YN_WIN_V){
		yesno.column = 1;
		yesno.line   = 2;
		yesno.lmenux = 0;
		yesno.lmenuy = def & 0x01;
	} else {
		yesno.column = 2;
		yesno.line   = 1;
		yesno.lmenux = def & 0x01;
		yesno.lmenuy = 0;
	}

	return menu(x,y,yesno);
}


/******************************************
 *                                        *
 * TO MENU CHK ( C+START )
 *                                        *
 ******************************************/



void tomenuchk(Uint8 d)
{
	if((device[d].Btn.S && device[d].Btn.C) ||
	   (device[d].Btn.S && device[d].Btn.ClickM)){
		MenuDev = d;
		ProgramMode = MENU;
	}
}


/*----------------------------------------*
 *                                        *
 * GET MENU DEVICE
 * called by selmenu
 -----------------------------------------*/


void getmenudev(void)
{
	Uint8 i;

	MenuDevChg = OFF;

	for(i = 0;i < PERMAX; i++){
		if(device[i].SaturnID == STDPAD ||
		   device[i].SaturnID == MD3BPAD ||
		   device[i].SaturnID == AX3STK ||
		   device[i].SaturnID == STAIR ||
		   device[i].SaturnID == KEYBRD ||
		   device[i].SaturnID == MD6BPAD){
			MenuDev = i;
			return;
		}
	}
	MenuDev = 0xff;
}


/*************
 MSG_WAIT
 *************/

void msg_wait(Uint8,Uint8,Sint8 *);

void msg_wait(Uint8 x,Uint8 y,Sint8 *msg)
{
    Uint8 i;

    box(x,y,16,2);
    putstr(x+1,y+2,msg,WHITE);

    for(i = 0; i< 0x7fff; i++)
      ;
}

/***********
 DEBUG_MENU
 ***********/

#define PUTBTN(btn1,btn2,x) if(device[d].Btn.btn1) putstr(26+x,d,btn2,0);  else putstr(26+x,d," ",0)

debug_menu()
{
    Uint8 d;
    Uint8 i;

    for(d = 0; d < PERMAX; d++){
	putstr(0,d,device[d].shortname,0);
	putstr(7,d,itos(device[d].SaturnID,16,2),0);
	for(i=0;i<device[d].datamax;i++)
	  putstr(10+i*3,d,itos(device[d].data[i],16,2),0);

	PUTBTN(A,"A",0);
	PUTBTN(B,"B",1);
	PUTBTN(C,"C",2);
	PUTBTN(X,"X",3);
	PUTBTN(Y,"Y",4);
	PUTBTN(Z,"Z",5);
	PUTBTN(S,"S",6);
	PUTBTN(L,"L",7);
	PUTBTN(R,"R",8);
	PUTBTN(Up,  "a",9);
	PUTBTN(Down,"b",10);
	PUTBTN(Left,"c",11);
	PUTBTN(Right,"d",12);

    }
#if 1
    putstr(0,14,"V",0);
#endif
    putstr(0,15,itos(port[0].id,16,2),0);
}

/*************************** END MENU.C *************************/
