/******************************************
 *                                        *
 *   SMPC SAMPLE PROGRAM Version 0.56a    *
 *                                        *
 *    file : ppmrbg.h                     *
 *                                        *
 *  author : s.uchida sega cs h/w r&d     *
 *                                        *
 *    date : 94/11/09                     *
 *                                        *
 ******************************************/


#include "ssp.h"

#define ROLL_X(x) pokew(0x25e50044,x)
#define ROLL_Y(y) pokew(0x25e50048,y)
#define SCALE(x)  {pokel(0x25e5004c,FIXED(x));\
			      pokel(0x25e50050,FIXED(x));}

static Sint16 rbg_x,rbg_y;
static Float32 rbg_k;
static Float32 rx,ry,rz;


/******************************************
 *                                        *
 * RBG PORT MONI
 * main loop
 ******************************************/


RbgPortMoni()
{
	Uint16 i;

	init_screen();
	SpCmdInit();

	rparam_init();

	while(ProgramMode == PPMRBG)
	  MainLoopCount++;

	rparam_init();

}


/*----------------------------------------*
 *                                        *
 * RPARAM INIT
 *                                        *
 -----------------------------------------*/


rparam_init()
{
	rbg_x = rbg_y = 0;
	rbg_k = 1;
	rx = ry = rz = 0;

	ROLL_X(rbg_x);
	ROLL_Y(rbg_y);
	SCALE(rbg_k);
}


/*----------------------------------------*
 *                                        *
 * RBG PAD ACTION
 * vblank in
 -----------------------------------------*/


void rbg_pad_action(Uint8 d)
{
	Uint8 i;

	for(i = 0; i < PERMAX; i++)
	  tomenuchk(i);


	if(device[d].Btn.S)			/* X^[g{^ꂽʂ */
	  rparam_init();

	if(device[d].Btn.Up){		/* XN[ */
		rbg_y -= 2;
		if(rbg_y < 0)
		  rbg_y = 510;
		ROLL_Y(rbg_y);
	}

	if(device[d].Btn.Down){		/* XN[ */
		rbg_y += 2;
		if(rbg_y > 510)
		  rbg_y = 0;
		ROLL_Y(rbg_y);
	}

	if(device[d].Btn.Left){		/* EXN[ */
		rbg_x -= 2;
		if(rbg_x < 0)
		  rbg_x = 510;
		ROLL_X(rbg_x);
	}

	if(device[d].Btn.Right){	/* XN[ */
		rbg_x += 2;
		if(rbg_x > 510)
		  rbg_x = 0;
		ROLL_X(rbg_x);
	}

	if(device[d].Btn.A){		/* g */
		rbg_k -= 0.01;
		if(rbg_k < 0)
		  rbg_k = 0;
		SCALE(rbg_k);
	}

	if(device[d].Btn.B){		/* k */
		rbg_k += 0.01;
		if(rbg_k > 3)
		  rbg_k = 3;
		SCALE(rbg_k);
	}


}


/*****************END PPMRBG.C************************/
