/******************************************
 *                                        *
 *   SMPC SAMPLE PROGRAM Version 0.56a    *
 *                                        *
 *    file : ppmspr.c                     *
 *                                        *
 *  author : s.uchida sega cs h/w r&d     *
 *                                        *
 *    date : 94/11/09                     *
 *
 *    Functions: PortMoni()
								 void pad_action(void);
								 void pad_digital(Uint8 i)
								 void pad_ax3stk(Uint8 i)
								 void pad_mouse(Uint8 i)
								 void pad_stair(Uint8 i)
								 void pad_none(Uint8 i)
								 void pad_digital_sub(Uint8 i)
								 void spzoomchk(Uint8 i)
								 void spzoomset(Uint8 i,Uint16 xz,Uint16 yz)

 ******************************************/

#include "ssp.h"

#define SPRXMAX (319 - 8)
#define SPRYMAX (223 - 8)
#define SPRXMIN (8)
#define SPRYMIN (8)
#define SPRXINT (16)
#define SPRYINT(i) (43 + i * 8 - (i > 14) * 40)


/******************************************
 *                                        *
 * PORT MONI
 * main loop
 ******************************************/


PortMoni()
{
	Uint8 i;

	init_screen();
	SpCmdInit();

	for(i = 0; i < PERMAX; i++){
		spcmd[i][LOCATE][XA] = spr[i].x = SPRXINT;
		spcmd[i][LOCATE][YA] = spr[i].y = SPRYINT(i);
		spr[i].zoomenable = DISABLE;
	}

/*ADEBUG*/
	rparam_init();

	while(ProgramMode == PPMSPR)
	  MainLoopCount++;

/*ADEBUG*/
	rparam_init();


}

/************/
/*PAD ACTION*/
/*VBLANK IN */
/************/
void pad_action(void);

void pad_action(void)
{
	Uint8 i;
	void pad_digital(Uint8 i);
	void pad_ax3stk(Uint8 i);
	void pad_stair(Uint8 i);
	void pad_mouse(Uint8 i);
	void pad_none(Uint8 i);

/*for all devices*/
	for(i = 0; i < PERMAX; i++)
	{
/*check for C+START*/
/*ADEBUG*/
/*		tomenuchk(i);*/
/*port id more than one tap*/
		if((port[i / PORTMAX].id & 0x0f) != 1)
			spcmd[i][PATTERN][PTNADRS] = SPBASE + SPSTEP + (i % PORTMAX) * SPSTEP;
/*port id direct connect*/
		else spcmd[i][PATTERN][PTNADRS] = SPBASE;

		spcmd[i][PATTERN][COLBANK] = COLBASE + COLSTEP * (i / PORTMAX);


		switch(device[i].SaturnID){
			case STDPAD:
			case MD3BPAD:
			case MD6BPAD:
			case KEYBRD:
				pad_digital(i);
				break;
			case AX3STK:
				pad_ax3stk(i);
				break;
			case MOUSE:
				pad_mouse(i);
				break;
			case STAIR:
				pad_stair(i);
				break;
			default:
				pad_none(i);
				spcmd[i][PATTERN][PTNADRS] = SPNULL;
				break;
		}
	}
	spcmd[PERMAX][ENDCMD][CMD] = 0x8000;
	memcpy(SPRVRM,spcmd,CMDSIZ);
}

/*************/
/*PAD DIGITAL*/
/*************/
void pad_digital(Uint8 i)
{
	Uint16 j;
	void pad_digital_sub(Uint8);
	void spzoomchk(Uint8);
	pad_digital_sub(i);
	spzoomchk(i);

	if(device[i].Btn.Up)
		if(spr[i].y<=SPRYMIN) spr[i].y = SPRYMIN;
			else spr[i].y = spr[i].y - spr[i].speed;

	if(device[i].Btn.Down)
		if(spr[i].y>=SPRYMAX) spr[i].y = SPRYMAX;
			else spr[i].y = spr[i].y + spr[i].speed;

	if(device[i].Btn.Left)
		if(spr[i].x<=SPRXMIN) spr[i].x = SPRXMIN;
			else spr[i].x = spr[i].x -spr[i].speed;

	if(device[i].Btn.Right)
		if(spr[i].x>=SPRXMAX) spr[i].x = SPRXMAX;
			else spr[i].x = spr[i].x + spr[i].speed;

	spcmd[i][LOCATE][XA] = spr[i].x;
	spcmd[i][LOCATE][YA] = spr[i].y;
}

/********/
/*AX3STK*/
/********/
void pad_ax3stk(Uint8 i)
{
	Uint16 j;
	void pad_digital_sub(Uint8);
	void spzoomset(Uint8,Uint16,Uint16);

	pad_digital_sub(i);

	if(device[i].Btn.B){
		if(device[i].Btn.Up)
			if(spr[i].y<=SPRYMIN) spr[i].y = SPRYMIN;
				else spr[i].y = spr[i].y - spr[i].speed;

		if(device[i].Btn.Down)
			if(spr[i].y>=SPRYMAX) spr[i].y = SPRYMAX;
				else spr[i].y = spr[i].y + spr[i].speed;

		if(device[i].Btn.Left)
			if(spr[i].x<=SPRXMIN) spr[i].x = SPRXMIN;
				else spr[i].x = spr[i].x - spr[i].speed;

		if(device[i].Btn.Right)
			if(spr[i].x>=SPRXMAX) spr[i].x = SPRXMAX;
				else spr[i].x = spr[i].x + spr[i].speed;
	}

	spcmd[i][LOCATE][XA] = spr[i].x;
	spcmd[i][LOCATE][YA] = spr[i].y;
/*ADEBUG*/
/*	spcmd[i+1][LOCATE][XA] = spr[i+1].x;
	spcmd[i+1][LOCATE][YA] = spr[i+1].y;
*/
	if(!device[i].Btn.B){
		spcmd[i][LOCATE][XA] += device[i].data[2] - 0x80;
		spcmd[i][LOCATE][YA] += device[i].data[3] - 0x80;
	}
/*ADEBUG*/
/*	if(!device[i].Btn.B){
		spcmd[i+1][LOCATE][XA] += device[i+1].data[2] - 0x80;
		spcmd[i+1][LOCATE][YA] += device[i+1].data[3] - 0x80;
	}
*/

	j = spr[i].zoomenable ? device[i].data[4] / 2 : 8;

	spzoomset(i,j,j);

}


/***********/
/*PAD MOUSE*/
/***********/
void pad_mouse(Uint8 i)
{

	Uint8 yOver,xOver,ySign,xSign;
	Uint16 zoomx,zoomy;

	void spzoomset(Uint8,Uint16,Uint16);

	if(device[i].Btn.S){
		spr[i].x = SPRXINT;
		spr[i].y = SPRYINT(i);
		spr[i].zoomenable = 0;
		spr[i].zoom = 0x0f;
	}

	zoomx = device[i].Btn.ClickL ? 16 : 8;
	zoomy = device[i].Btn.ClickR ? 16 : 8;

	spzoomset(i,zoomx,zoomy);

	yOver = (device[i].data[0] >> 7) & 1;
	xOver = (device[i].data[0] >> 6) & 1;
	ySign = (device[i].data[0] >> 5) & 1;
	xSign = (device[i].data[0] >> 4) & 1;

	if(xSign) spr[i].x -= (device[i].data[1] ^ 0xff) >> 2;
		else spr[i].x += device[i].data[1] >> 2;
	if(ySign) spr[i].y += (device[i].data[2] ^ 0xff) >> 2;
		else spr[i].y -= device[i].data[2] >> 2;

	if(spr[i].x >= SPRXMAX) spr[i].x = SPRXMAX;
	if(spr[i].y >= SPRYMAX) spr[i].y = SPRYMAX;
	if(spr[i].x <= SPRXMIN) spr[i].x = SPRXMIN;
	if(spr[i].y <= SPRYMIN) spr[i].y = SPRYMIN;

	spcmd[i][LOCATE][XA] = spr[i].x;
	spcmd[i][LOCATE][YA] = spr[i].y;
}

/***********/
/*PAD STAIR*/
/***********/
void pad_stair(Uint8 i)
{
	Uint16 j;
	void pad_digital_sub(Uint8);
	void spzoomchk(Uint8);

	pad_digital_sub(i);
	spzoomchk(i);

	if(device[i].Btn.Up)
		if(spr[i].y<=SPRYMIN) spr[i].y = SPRYMIN;
			else spr[i].y = spr[i].y - spr[i].speed;

	if(device[i].Btn.Down)
		if(spr[i].y>=SPRYMAX) spr[i].y = SPRYMAX;
			else spr[i].y = spr[i].y + spr[i].speed;

	if(device[i].Btn.B){
		if(device[i].Btn.Left)
			if(spr[i].x<=SPRXMIN) spr[i].x = SPRXMIN;
				else spr[i].x = spr[i].x - spr[i].speed;

		if(device[i].Btn.Right)
			if(spr[i].x>=SPRXMAX) spr[i].x = SPRXMAX;
				else spr[i].x = spr[i].x + spr[i].speed;
	}
	spcmd[i][LOCATE][XA] = spr[i].x;
	spcmd[i][LOCATE][YA] = spr[i].y;

	if(!device[i].Btn.B) spcmd[i][LOCATE][XA] += device[i].data[2] - 0x80;
}

/**********/
/*PAD NONE*/
/**********/
void pad_none(Uint8 i)
{
	void spzoomset(Uint8,Uint16,Uint16);

	spcmd[i][LOCATE][XA] = spr[i].x = SPRXINT;
	spcmd[i][LOCATE][YA] = spr[i].y = SPRYINT(i);

	spzoomset(i,8,8);
}

/*****************/
/*PAD DIGITAL SUB*/
/*****************/
void pad_digital_sub(Uint8 i)
{

	if(device[i].Btn.S){
		spr[i].x = SPRXINT;
		spr[i].y = SPRYINT(i);
		spr[i].zoomenable = 0;
		spr[i].zoom = 0x0f;
	}

	spr[i].speed = device[i].Btn.A ? 4 : 1;

	if(device[i].Btn.X && !device[i].lBtn.X)
		spr[i].zoomenable ^= 1;

}

/***********/
/*SPZOOMCHK*/
/***********/
void spzoomchk(Uint8 i)
{
	Uint16 j;
	void spzoomset(Uint8,Uint16,Uint16);

	if(spr[i].zoomenable){
		if(device[i].Btn.Y){
			spr[i].zoom++;
			if(spr[i].zoom > 0xff)
				spr[i].zoom = 0xff;
		}
		if(device[i].Btn.Z){
			spr[i].zoom--;
			if(spr[i].zoom < 0)
				spr[i].zoom = 0;
		}
		j = spr[i].zoom;
	} else j = 8;

	spzoomset(i,j,j);
}

/***********/
/*SPZOOMSET*/
/***********/
void spzoomset(Uint8 i,Uint16 xz,Uint16 yz)
{
	spcmd[i][PATTERN][XA] = -xz;
	spcmd[i][PATTERN][YA] = -yz;
	spcmd[i][PATTERN][XB] =  xz - 1;
	spcmd[i][PATTERN][YB] = -yz;
	spcmd[i][PATTERN][XC] =  xz - 1;
	spcmd[i][PATTERN][YC] =  yz - 1;
	spcmd[i][PATTERN][XD] = -xz;
	spcmd[i][PATTERN][YD] =  yz - 1;
}

/******************* END PPMSPR.C *************************/
