/******************************************
 *                                        *
 *   SMPC SAMPLE PROGRAM Version 0.56a    *
 *                                        *
 *    file : ppm_.c                       *
 *                                        *
 *  author : s.uchida sega cs h/w r&d     *
 *                                        *
 *    date : 94/11/09                     *
 *                                        *
			Functions: void screenout(void)
								 void PrintDeviceData(Uint8 no,Uint8 line)
								 void init_screen(void)

 ******************************************/


#include "ssp.h"


/******************************************
 *                                        *
 * SCREEN OUT
 * vblank in
 ******************************************/


void screenout(void)
{
	Uint8 i,j,dno,y,pno;

	for(i = 0;i < 2;i++){
		if(port[i].chg)
			for(j = 0;j < 7;j++)
				putstr(3,TOPLINE+5+j+i*10,"                                    ",WHITE);
/*port name*/
		putstr(11,TOPLINE+3+i*10,port[i].name,SKYBLUE);
/*port id*/
		putstr(35,TOPLINE+3+i*10,itosh2(port[i].id),SKYBLUE);
/*pno = number of taps, 1 or 6*/
		pno = port[i].id & 0x0f;
		if(pno > 7)
		  pno = 7;
/*for all taps*/
		for(j = 0;j < pno;j++)
		{
			dno = j + i * PORTMAX;
			y = TOPLINE + dno + 5 - i * 5;
/*if multitap put number 1-6*/
			if(pno>1) putstr(3,y,itos(j+1,10,1),GREEN);
/*device NAME*/
			putstr(5,y,device[dno].name,GREEN);
/*device ID*/
			putstr(19,y,"(",GREEN);
			putstr(22,y,")",GREEN);
			putstr(20,y,itosh2(device[dno].SaturnID),GREEN);
/*device data[bytes]*/
			PrintDeviceData(dno,y);
		} /*for all taps*/
	} /*for all ports*/
}

/*----------------------------------------*
 *                                        *
 * PRINT DEVICE DATA
 * called by screenout                    *
 -----------------------------------------*/

void PrintDeviceData(Uint8 no,Uint8 line)
{
	Uint8 i,max;

/*ADEBUG*/
/*	max = device[no].datamax>5 ? 5 : device[no].datamax; */

	max = device[no].datamax>9 ? 9 : device[no].datamax;

	putstr(24,line,"              ",WHITE);
	for(i = 0;i < max;i++)
		putstr(24+i*3,line,itosh2(device[no].data[i]),BLACK);
/*ADEBUG*/

/*	if(device[no].SaturnID == AX3STK)
	{
	 	putstr(91,line,itosh2(device[no].data[0]),BLACK);
		putstr(94,line,itosh2(device[no].data[2]),BLACK);
		putstr(97,line,itosh2(device[no].data[3]),BLACK);
		putstr(100,line,itosh2(device[no].data[4]),BLACK);
	}
*/

}


/******************************************
 *                                        *
 * INIT SCREEN
 *                                        *
 ******************************************/


void init_screen(void)
{
	gcls();
	box(0,1,38,20);
	putstr( 8, TOPLINE+1,"[PERIPHERAL PORT MONITOR]",YELLOW);
	putstr( 2, TOPLINE+3,"PORT 1 : ",SKYBLUE);
	putstr(34, TOPLINE+3,"(  )",SKYBLUE);
	putstr( 2,TOPLINE+13,"PORT 2 : ",SKYBLUE);
	putstr(34,TOPLINE+13,"(  )",SKYBLUE);

	statusline();
}

/************************ END PPM_.C *************************/
