/******************************************
 *                                        *
 *   SMPC SAMPLE PROGRAM Version 0.56a    *
 *                                        *
 *    file : spaint.h                     *
 *                                        *
 *  author : s.uchida sega cs h/w r&d     *
 *                                        *
 *    date : 94/11/09                     *
 *                                        *
 ******************************************/

#include "ssp.h"

#define PAINT_PSET 0
#define PAINT_LINE 1
#define PAINT_CIRC 2
#define PAINT_OVAL 3
#define PAINT_BOX  4
#define PAINT_BOXF 5
#define PAINT_CLS  11
#define PAINT_COL  12
#define PAINT_PEN  13
#define PAINT_CONF 15

#define MOUSE_CURSOR_ON_PAPER ((mousex>=0) && (mousex <256) && (mousey>=0) && (mousey<192))
#define MOUSE_CURSOR_ON_ICON  ((mousex>=256) && (mousex <320) && (mousey>=0) &&(mousey<64))

#define MOUSE_CLICKL(i) (device[i].Btn.ClickL && !device[i].lBtn.ClickL)
#define MOUSE_CLICKM(i) (device[i].Btn.ClickM && !device[i].lBtn.ClickM)
#define MOUSE_CLICKR(i) (device[i].Btn.ClickR && !device[i].lBtn.ClickR)
#define MOUSE_CLICKS(i) (device[i].Btn.S      && !device[i].lBtn.S)

#define LINEMODE_START_POINT 0
#define LINEMODE_END_POINT   1

#define XORC 0x70

#define PSET 0x00
#define XOR  0x01
#define BOX  0x02


#define MOUSE_MOVE 0
#define MOUSE_DRGL 1
#define MOUSE_DRGM 2
#define MOUSE_DRGR 3
#define MOUSE_CLKL 4
#define MOUSE_CLKM 5
#define MOUSE_CLKR 6

#define SWAP(a,b) {Uint8 wrk;wrk = a;a = b;b = wrk;}

Sint16 lmousex = 128;
Sint16 mousex = 128;
Sint16 lmousey = 96;
Sint16 mousey = 96;


static Sint16 line_startx,line_starty,line_endx,line_endy;
static Sint16 tmp_x,tmp_y;
static Uint8 MoveOutPaper = ENABLE;
static Uint8 PaintMode;
static Uint8 LineMode = LINEMODE_START_POINT;

Uint8 pencolor = 0x00;

void Paint_Main(void);
void PaintTool(void);




/******************************************
 *                                        *
 * yCgc[                         *
 *                                        *
 ******************************************/


void PaintTool(void)
{
	Uint16 i,j;
	void Paint_init(void);

	PaintMode = PAINT_PSET;
	LineMode  = LINEMODE_START_POINT;

	Paint_init();

	while(ProgramMode == PAINT){
		MainLoopCount++;

		if(MOUSE_CURSOR_ON_ICON && MOUSE_CLICKL(0)){
			PaintMode = (mousex - 256) / 16 + (mousey / 16) * 4;

			if(PaintMode == PAINT_CLS)
			  clear_paper(0xffffffff);
		}

		if(MOUSE_CURSOR_ON_PAPER)
		  if(LineMode == LINEMODE_END_POINT
		    || device[0].Btn.ClickL)
		      MoveOutPaper = DISABLE;
		else MoveOutPaper = ENABLE;

		if(MOUSE_CURSOR_ON_PAPER)
		  switch(PaintMode){
			case PAINT_PSET:
			  paint_pset2();
			  break;
			case PAINT_LINE:
			  paint_line2();
			  break;
			case PAINT_CIRC:
			  paint_circ();
			  break;
			case PAINT_OVAL:
			  paint_oval();
			  break;
			case PAINT_BOX:
			  paint_box2();
			  break;
			case PAINT_BOXF:
			  paint_boxf();
			  break;
			case PAINT_COL:
			  paint_col();
			  break;
			case PAINT_PEN:
			  paint_pen();
			  break;
			case PAINT_CONF:
			  paint_conf();
			  break;
			default:
			  break;
		  }
	}

	clear_paper(0);

}




/*----------------------------------------*
 *                                        *
 * yCgc[                   *
 *                                        *
 -----------------------------------------*/


void Paint_init(void)
{
	Uint16 i,j,k,l;

	gcls();
	statusline();
	initmenuicon();
	clear_paper(0xffffffff);


	MoveOutPaper = ENABLE;
	box(32,16,6,2);

	box(32,20,6,2);
	putstr(33,17,"X:",WHITE);
	putstr(33,18,"Y:",WHITE);

	for(i = 0; i < 30; i++)
		for(j = 0; j < 4; j++)
			for(k = 0; k < 16; k++)
				spcmd[i][j][k] = 0;

	for(i = 0; i < 17; i++){
		spcmd[i][SYSCLIP][CMD]  = 0x0009;
		spcmd[i][SYSCLIP][XC]   = 0x013f;
		spcmd[i][SYSCLIP][YC]   = 0x00ff;

		spcmd[i][USRCLIP][CMD]  = 0x0008;
		spcmd[i][USRCLIP][XA]   = 0x0000;
		spcmd[i][USRCLIP][YA]   = 0x0000;
		spcmd[i][USRCLIP][XC]   = 0x013f;
		spcmd[i][USRCLIP][YC]   = 0x00ff;

		spcmd[i][PATTERN][CMD]  = 0x0002;
		spcmd[i][PATTERN][MODE] = 0x00a0;
		spcmd[i][PATTERN][COLBANK] = 0x0000;
		spcmd[i][PATTERN][CHARSIZ] = 0x0210;
		spcmd[i][PATTERN][PTNADRS] = 0x4000 + i * 0x20;
		spcmd[i][PATTERN][XA] = 0;
		spcmd[i][PATTERN][YA] = 0;
		spcmd[i][PATTERN][XB] = 15;
		spcmd[i][PATTERN][YB] = 0;
		spcmd[i][PATTERN][XC] = 15;
		spcmd[i][PATTERN][YC] = 15;
		spcmd[i][PATTERN][XD] = 0;
		spcmd[i][PATTERN][YD] = 15;
		spcmd[i][PATTERN][COLBANK] = 0x0000;

		spcmd[i][LOCATE][CMD]   = 0x000a;
		spcmd[i][LOCATE][XA] = 256 + (i % 4) * 16;
		spcmd[i][LOCATE][YA] =   0 + (i / 4) * 16;
	}


	spcmd[16][LOCATE][XA] = mousex;
	spcmd[16][LOCATE][YA] = mousey;

	spcmd[17][ENDCMD][CMD] = 0x8000;
/*USE MEMCPY INSTEAD OF MEMCPY_W !!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
	memcpy(SPRVRM,spcmd,CMDSIZ);

}



/*----------------------------------------*
 *                                        *
 * 쐬                               *
 *                                        *
 -----------------------------------------*/


clear_paper(Uint32 color)
{
	Uint16 i,j;
	Uint32 *ptr;

	ptr = (Uint32 *)0x25e20000;

	for(i = 0; i < 192;i++){
		for(j = 0; j < 64; j++)
		  *ptr++ = color;
		ptr += 0x40;
	}


}


/******************************************
 *                                        *
 * uuNĂ΂c[{       *
 *                                        *
 ******************************************/


void Paint_Main(void)
{
	Uint8 yOver,xOver,ySign,xSign;
	Uint8 i = 0;
	Uint8 j;
	Sint16 xlimit;
	Sint16 tmp_x,tmp_y;

	lmousex = mousex;
	lmousey = mousey;
	yOver = (device[i].data[0]>>7) & 1;
	xOver = (device[i].data[0]>>6) & 1;
	ySign = (device[i].data[0]>>5) & 1;
	xSign = (device[i].data[0]>>4) & 1;

	if(xSign) mousex -= ((device[i].data[1] ^ 0xff) >> 1);
		else mousex += device[i].data[1] >> 1;
	if(ySign) mousey += ((device[i].data[2] ^ 0xff) >> 1);
		else mousey -= device[i].data[2] >> 1;

	xlimit = (MoveOutPaper == ENABLE) ? 311 : 255;

	if(mousex > xlimit)
	  mousex = xlimit;

	if(mousey > 191)
	  mousey = 191;

	if(mousex < 0)
	  mousex = 0;

	if(mousey < 0)
	  mousey = 0;

	for(j = 0; j < 16; j++)
		if(PaintMode == j)
			spcmd[j][PATTERN][COLBANK] = 0x0200;
		else
			spcmd[j][PATTERN][COLBANK] = 0x0000;

	spcmd[16][LOCATE][XA] = mousex;
	spcmd[16][LOCATE][YA] = mousey;

	memcpy(SPRVRM,spcmd,CMDSIZ);

#if 0
	if(MOUSE_CLICKL(0))							/* fobOCg */
		putstr(18,0,"L",WHITE);
	else putstr(18,0," ",WHITE);

	if(MOUSE_CLICKM(0))
		putstr(19,0,"M",WHITE);
	else putstr(19,0," ",WHITE);

	if(MOUSE_CLICKR(0))
		putstr(20,0,)"R",WHITE);
	else putstr(20,0," ",WHITE);

        putstr(35,13,itosh2(LineMode),WHITE);
        putstr(35,14,itosh2(MoveOutPaper),WHITE);
#endif

	putstr(35,17,itos(mousex,10,3),WHITE);
	putstr(35,18,itos(mousey,10,3),WHITE);
	putfdev(33,21,i);

	for(i = 0; i < PERMAX; i++)
	  tomenuchk(i);

}




/*----------------------------------------*
 *                                        *
 * RȐ                               *
 *                                        *
 -----------------------------------------*/


paint_pset2()
{
	SyncVBin();
	if(device[0].Btn.ClickL){
		paint_line(lmousex,lmousey,mousex,mousey,pencolor,PSET);

	}
}


/*----------------------------------------*
 *                                        *
 * _ł                               *
 *                                        *
 -----------------------------------------*/


paint_pset(Uint8 x,Uint8 y,Uint8 col,Uint8 flag)
{
	if(flag & XOR)
	  *(Uint8 *)(0x25e20000 + x + y * 512) ^= col;
	else
	  *(Uint8 *)(0x25e20000 + x + y * 512) = col;
}



/*----------------------------------------*
 *                                        *
 * E{bNX`                   *
 *                                        *
 -----------------------------------------*/


paint_line(Sint16 x1,Sint16 y1,Sint16 x2,Sint16 y2,Uint8 col,Uint8 flag)
{
	Sint16 xd,yd;
	Sint16 i,j,k;
	double d;

	if(flag & BOX){
		paint_box(x1,y1,x2,y2,col,flag);
		return;
	}

	xd = x2 - x1;
	yd = y2 - y1;

	if(abs(xd) > abs(yd)){
		d = (double)yd / (double)xd;
		if(x1 > x2){
			SWAP(x1,x2);
			SWAP(y1,y2);
		}
		for(i = 0; i < abs(xd); i++)
			paint_pset(x1 + i,(y1 + i * d + 0.5),col,flag);
	} else {
		d = (double)xd / (double)yd;
		if(y1 > y2){
			SWAP(x1,x2);
			SWAP(y1,y2);
		}
		for(i = 0; i < abs(yd); i++)
			paint_pset(x1 + (i * d + 0.5),y1 + i,col,flag);
	}
}




paint_circ()
{
}

paint_oval()
{
}




/*----------------------------------------*
 *                                        *
 * {bNX`i{́j                 *
 *                                        *
 -----------------------------------------*/


paint_box(Sint16 x1,Sint16 y1,Sint16 x2,Sint16 y2,Uint8 col,Uint8 flag)
{
	Sint16 d;
	Sint16 i;
	Sint16 tmp;
#if 1
	d = abs(x2 - x1);
	tmp = (x1 > x2) ? x2 : x1;

	for(i = 0; i <= d; i++){
		paint_pset(tmp + i,y1,col,flag);
		paint_pset(tmp + i,y2,col,flag);
	}
#endif
#if 1
	d = abs(y2 - y1);
	tmp = (y1 > y2) ? y2 : y1;

	for(i = 1; i < d; i++){
		paint_pset(x1,tmp + i,col,flag);
		paint_pset(x2,tmp + i,col,flag);
	}
#endif
}





paint_boxf()
{
}

paint_col()
{
}

paint_pen()
{
}

paint_conf()
{
}


/*----------------------------------------*
 *                                        *
 * `                             *
 *                                        *
 -----------------------------------------*/


paint_line2()
{

	SyncVBin();
	switch(LineMode){
	      case LINEMODE_START_POINT:
		paint_line_startpoint();
		break;
	      case LINEMODE_END_POINT:
		paint_line_endpoint(XOR);
		break;
	}
}


/*----------------------------------------*
 *                                        *
 * {bNX`                         *
 *                                        *
 -----------------------------------------*/


paint_box2()
{

	SyncVBin();
	switch(LineMode){
	      case LINEMODE_START_POINT:
		paint_line_startpoint();
		break;
	      case LINEMODE_END_POINT:
		paint_line_endpoint(BOX | XOR);
		break;
	}
}


/*----------------------------------------*
 *                                        *
 * ̎n_߂                     *
 *                                        *
 -----------------------------------------*/


paint_line_startpoint()
{
	MoveOutPaper = ENABLE;

	if(MOUSE_CLICKL(0)){
		line_startx = line_endx = mousex;
		line_starty = line_endy = mousey;

		LineMode = LINEMODE_END_POINT;
	}
}

/*----------------------------------------*
 *                                        *
 * ̏I_߁A`悷             *
 *                                        *
 -----------------------------------------*/

paint_line_endpoint(Uint8 flag)
{
	Uint8 endxy_chg = OFF;

	MoveOutPaper = DISABLE;

	tmp_x = mousex;
	tmp_y = mousey;

	if((line_endx != tmp_x) || (line_endy != tmp_y))
	  endxy_chg = ON;

	if(endxy_chg)
	  paint_line(line_startx,line_starty,line_endx,line_endy,XORC,flag | XOR);

	line_endx = tmp_x;
	line_endy = tmp_y;

	if(endxy_chg)
	  paint_line(line_startx,line_starty,line_endx,line_endy,XORC,flag | XOR);

	if(MOUSE_CLICKR(0)){
		paint_line(line_startx,line_starty,line_endx,line_endy,XORC,flag | XOR);
		LineMode = LINEMODE_START_POINT;
	}

	if(MOUSE_CLICKL(0)){
		paint_line(line_startx,line_starty,line_endx,line_endy,pencolor,flag & BOX);
		line_startx = line_endx;
		line_starty = line_endy;
		if(flag & BOX)
		  LineMode = LINEMODE_START_POINT;
	}
}



/******************************************
 *                                        *
 * uuNhmɓ               *
 *                                        *
 ******************************************/

SyncVBin()
{
	Sint16 check = VBinCount;

	while(check == VBinCount)
	  ;
}

